<template>
  <section class="profile-photo-change">
    <modal
      id="photoChangeModal"
      ref="modal"
      size="360px"
      color="primary"
      :loading="loading"
      :show.sync="show"
      :simple="true"
      :footer="false"
      :can-skip="noImage"
    >
      <i v-if="!loading" class="ic-close modal-close" @click="show = false" />
      <cropper
        v-model="cropper"
        style="display: block"
        :width="300"
        :height="300"
        canvas-color="default"
        placeholder="انتخاب تصویر"
        :placeholder-font-size="0"
        :placeholder-color="'default'"
        :accept="'image/*'"
        :file-size-limit="0"
        :quality="1"
        :zoom-speed="20"
        :disabled="false"
        :disable-drag-and-drop="false"
        :disable-click-to-choose="false"
        :disable-drag-to-move="false"
        :disable-scroll-to-zoom="false"
        :disable-rotation="false"
        :prevent-white-space="true"
        :reverse-scroll-to-zoom="false"
        :show-remove-button="false"
        :remove-button-color="'#777'"
        :remove-button-size="0"
        :initial-image="value"
        @init="handleCropperInit"
        @file-choose="handleCropperFileChoose"
        @file-size-exceed="handleCropperFileSizeExceed"
        @file-type-mismatch="handleCropperFileTypeMismatch"
        @new-image-drawn="handleNewImage"
        @image-remove="handleImageRemove"
        @move="handleCropperMove"
        @zoom="handleCropperZoom"
      ></cropper>

      <footer class="mt-2">
        <button
          type="button"
          class="btn btn-default"
          :class="noImage ? 'btn-primary' : 'btn-default'"
          @click="cropper.chooseFile()"
        >
          انتخاب فایل
        </button>
        <button
          type="button"
          :disabled="noImage"
          class="btn btn-default"
          @click="cropper.rotate()"
        >
          چرخش
        </button>
        <button
          type="button"
          class="fa btn pl-20 pr-20"
          :disabled="noImage"
          :class="[
            noImage ? 'btn-outline-primary' : 'btn-primary',
            uploadUrl ? 'fa-upload' : 'fa-check'
          ]"
          @click="upload"
        >
          ذخیره
        </button>
      </footer>
    </modal>
  </section>
</template>

<script>
import Cropper from 'vue-croppa'
import 'vue-croppa/dist/vue-croppa.css'

export default {
  components: {
    cropper: Cropper.component
  },
  model: {
    prop: 'value',
    event: 'change'
  },
  props: {
    value: { type: String, default: '' },
    label: { type: String, default: 'تغییر لوگو' },
    id: { type: String, default: 'photo-change' },
    name: { type: String, default: 'image' },
    accept: { type: String, default: 'image/(jpeg|jpg|png|gif)' },
    placeholder: { type: String, default: '' },
    uploadUrl: { type: String, default: '' },
    canClear: { type: Boolean, default: false }
    //oldPhoto: {type: String, 'default': ''},
  },
  data() {
    return {
      preview: false,
      show: false,
      cropper: {},
      fileData: null,
      loading: false
    }
  },
  computed: {
    src() {
      return this.preview || this.value || this.placeholder
    },
    noImage() {
      return (
        typeof this.cropper.hasImage !== 'function' || !this.cropper.hasImage()
      )
    },
    readyToClear() {
      return this.canClear && this.fileData
    }
  },
  watch: {
    value: () => {}
  },
  created() {},
  mounted() {
    this.$nextTick(() => {})
  },
  methods: {
    labelClick() {
      if (this.readyToClear) {
        return this.clear()
      }
      this.show = true
    },
    handleCropperInit() {},
    handleCropperFileChoose() {},
    handleCropperFileSizeExceed() {},
    handleCropperFileTypeMismatch() {},
    handleNewImage() {},
    handleImageRemove() {},
    handleCropperMove() {},
    handleCropperZoom() {},
    upload() {
      if (this.noImage) return
      this.cropper.promisedBlob('image/jpeg', 0.8).then(blob => {
        if (this.uploadUrl) {
          let formData = new FormData()
          formData.append(this.name, blob, 'image.jpeg')
          this.axios.post(this.uploadUrl, formData).then(response => {
            this.show = false
            this.$message.success('تصویر به روز شد!')
            this.$emit('upload-success', response)
          })
        } else {
          this.fileData = blob
          this.preview = URL.createObjectURL(blob)
          this.$refs.modal.close()
        }
      })
    },
    clear() {
      this.preview = false
      this.fileData = null
    }
  }
}
</script>

<style lang="scss">
@import '../../assets/sass/variables';
#photoChangeModal {
  .modal-content {
    border-radius: 10px;
  }
  .modal-body {
    padding-bottom: 10px;
  }
  footer {
    width: 100%;
    display: flex;
    flex-wrap: wrap;
    justify-content: space-between;
    .btn {
      font-size: 0.75rem;
    }
  }
  .modal-close {
    position: absolute;
    top: -15px;
    right: -15px;
    color: white;
    background-color: $danger;
    padding: 10px;
    border-radius: 50%;
    cursor: pointer;
    z-index: 10;
  }
  .croppa-container {
    position: relative;
    border-radius: 5px;
    overflow: hidden;
    &:before {
      display: block;
      content: '';
      width: 100%;
      padding-bottom: 100%;
    }
    canvas {
      width: 100% !important;
      height: 100% !important;
      position: absolute;
      top: 0;
      left: 0;
    }
  }
}
</style>
